import { ElementRef, EventEmitter, OnInit, TemplateRef } from '@angular/core';
import { ClockFaceTime } from './models/clock-face-time.interface';
import { TimePeriod } from './models/time-period.enum';
import { Observable } from 'rxjs/Observable';
import { NgxMaterialTimepickerService } from './services/ngx-material-timepicker.service';
import { TimeUnit } from './models/time-unit.enum';
import { AnimationEvent } from '@angular/animations';
import { NgxMaterialTimepickerEventService } from './services/ngx-material-timepicker-event.service';
export declare enum AnimationState {
    ENTER = "enter",
    LEAVE = "leave",
}
export declare class NgxMaterialTimepickerComponent implements OnInit {
    private timepickerService;
    private eventService;
    selectedHour: Observable<ClockFaceTime>;
    selectedMinute: Observable<ClockFaceTime>;
    selectedPeriod: Observable<TimePeriod>;
    timePeriod: typeof TimePeriod;
    timeUnit: typeof TimeUnit;
    activeTimeUnit: TimeUnit;
    isOpened: boolean;
    animationState: AnimationState;
    cancelBtnTmpl: TemplateRef<Node>;
    confirmBtnTmpl: TemplateRef<Node>;
    timeSet: EventEmitter<string>;
    timepicker: ElementRef;
    constructor(timepickerService: NgxMaterialTimepickerService, eventService: NgxMaterialTimepickerEventService);
    ngOnInit(): void;
    onHourChange(hour: ClockFaceTime): void;
    onMinuteChange(minute: ClockFaceTime): void;
    changePeriod(period: TimePeriod): void;
    changeTimeUnit(unit: TimeUnit): void;
    setTime(): void;
    open(): void;
    close(): void;
    animationDone(event: AnimationEvent): void;
    onKeydown(e: KeyboardEvent): void;
}
